/**
 * @name array-group-str-omit-num-char
 * @fileoverview Groups array of strings by omitting number characters
 * @version 6.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-group-str-omit-num-char/}
 */

"use strict";var arrayGroupStrOmitNumChar=(()=>{var m=Object.defineProperty;var D=Object.getOwnPropertyDescriptor;var I=Object.getOwnPropertyNames,$=Object.getOwnPropertySymbols;var w=Object.prototype.hasOwnProperty,x=Object.prototype.propertyIsEnumerable;var b=(n,s,o)=>s in n?m(n,s,{enumerable:!0,configurable:!0,writable:!0,value:o}):n[s]=o,g=(n,s)=>{for(var o in s||(s={}))w.call(s,o)&&b(n,o,s[o]);if($)for(var o of $(s))x.call(s,o)&&b(n,o,s[o]);return n};var N=(n,s)=>{for(var o in s)m(n,o,{get:s[o],enumerable:!0})},S=(n,s,o,r)=>{if(s&&typeof s=="object"||typeof s=="function")for(let l of I(s))!w.call(n,l)&&l!==o&&m(n,l,{get:()=>s[l],enumerable:!(r=D(s,l))||r.enumerable});return n};var _=n=>S(m({},"__esModule",{value:!0}),n);var M={};N(M,{defaults:()=>v,groupStr:()=>H,version:()=>J});var C={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function y(n,s){if(!Array.isArray(n)||!n.length)return n;let o=g(g({},C),s),r,l;if(o.strictlyTwoElementsInRangeArrays&&!n.every((i,u)=>!Array.isArray(i)||i.length!==2?(r=u,l=i.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${r}th range (${JSON.stringify(n[r],null,4)}) has not two but ${l} elements!`);if(!n.every((i,u)=>!Array.isArray(i)||!Number.isInteger(i[0])||i[0]<0||!Number.isInteger(i[1])||i[1]<0?(r=u,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${r}th range (${JSON.stringify(n[r],null,4)}) does not consist of only natural numbers!`);let t=n.length**2,p=0;return Array.from(n).sort((i,u)=>(o.progressFn&&(p+=1,o.progressFn(Math.floor(p*100/t))),i[0]===u[0]?i[1]<u[1]?-1:i[1]>u[1]?1:0:i[0]<u[0]?-1:1))}var O={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function W(n,s){function o(e){return!!e&&typeof e=="object"&&!Array.isArray(e)}if(!Array.isArray(n)||!n.length)return null;let r;if(s)if(o(s)){if(r=g(g({},O),s),r.progressFn&&o(r.progressFn)&&!Object.keys(r.progressFn).length)r.progressFn=null;else if(r.progressFn&&typeof r.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof r.progressFn}", equal to ${JSON.stringify(r.progressFn,null,4)}`);if(![1,2,"1","2"].includes(r.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof r.mergeType}", equal to ${JSON.stringify(r.mergeType,null,4)}`);if(typeof r.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof r.joinRangesThatTouchEdges}", equal to ${JSON.stringify(r.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(s,null,4)} (type ${typeof s})`);else r=g({},O);let l=n.filter(e=>Array.isArray(e)).map(e=>[...e]).filter(e=>e[2]!==void 0||e[0]!==e[1]),t,p,i;r.progressFn?t=y(l,{progressFn:e=>{i=Math.floor(e/5),i!==p&&(p=i,r.progressFn(i))}}):t=y(l);let u=t.length-1;for(let e=u;e>0;e--)r.progressFn&&(i=Math.floor((1-e/u)*78)+21,i!==p&&i>p&&(p=i,r.progressFn(i))),(t[e][0]<=t[e-1][0]||!r.joinRangesThatTouchEdges&&t[e][0]<t[e-1][1]||r.joinRangesThatTouchEdges&&t[e][0]<=t[e-1][1])&&(t[e-1][0]=Math.min(t[e][0],t[e-1][0]),t[e-1][1]=Math.max(t[e][1],t[e-1][1]),t[e][2]!==void 0&&(t[e-1][0]>=t[e][0]||t[e-1][1]<=t[e][1])&&t[e-1][2]!==null&&(t[e][2]===null&&t[e-1][2]!==null?t[e-1][2]=null:t[e-1][2]!=null?+r.mergeType==2&&t[e-1][0]===t[e][0]?t[e-1][2]=t[e][2]:t[e-1][2]+=t[e][2]:t[e-1][2]=t[e][2]),t.splice(e,1),e=t.length);return t.length?t:null}var V=!0,f="Invariant failed";function E(n,s){if(!n){if(V)throw new Error(f);var o=typeof s=="function"?s():s,r=o?"".concat(f,": ").concat(o):f;throw new Error(r)}}function T(n,s,o){let r=0,l=0;if(arguments.length===0)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if(typeof n!="string")throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof n}, equal to: ${JSON.stringify(n,null,4)}`);if(s&&!Array.isArray(s))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof s}, equal to: ${JSON.stringify(s,null,4)}`);if(o&&typeof o!="function")throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof o}, equal to: ${JSON.stringify(o,null,4)}`);if(!s||!s.filter(a=>a).length)return n;let t;Array.isArray(s)&&Number.isInteger(s[0])&&Number.isInteger(s[1])?t=[Array.from(s)]:t=Array.from(s);let p=t.length,i=0;t.filter(a=>a).forEach((a,c)=>{if(o&&(r=Math.floor(i/p*10),r!==l&&(l=r,o(r))),!Array.isArray(a))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${c}th element not an array: ${JSON.stringify(a,null,4)}, which is ${typeof a}`);if(!Number.isInteger(a[0])){if(!Number.isInteger(+a[0])||+a[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${c}th element, array ${JSON.stringify(a,null,0)}. Its first element is not an integer, string index, but ${typeof a[0]}, equal to: ${JSON.stringify(a[0],null,4)}.`);t[c][0]=+t[c][0]}if(!Number.isInteger(a[1])){if(!Number.isInteger(+a[1])||+a[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${c}th element, array ${JSON.stringify(a,null,0)}. Its second element is not an integer, string index, but ${typeof a[1]}, equal to: ${JSON.stringify(a[1],null,4)}.`);t[c][1]=+t[c][1]}i+=1});let u=W(t,{progressFn:a=>{o&&(r=10+Math.floor(a/10),r!==l&&(l=r,o(r)))}});E(u);let e=u.length;if(e>0){let a=n.slice(u[e-1][1]);n=u.reduce((c,P,d,h)=>{o&&(r=20+Math.floor(d/e*80),r!==l&&(l=r,o(r)));let j=d===0?0:h[d-1][1],A=h[d][0];return`${c}${n.slice(j,A)}${h[d][2]||""}`},""),n+=a}return n}var R="6.0.5";var J=R,v={wildcard:"*",dedupePlease:!0};function H(n,s){if(!Array.isArray(n))return n;if(!n.length)return{};let o=g(g({},v),s),r=o.dedupePlease?[...new Set(n)]:Array.from(n),l={};for(let p=0,i=r.length;p<i;p++){let u=r[p].match(/\d+/gm);if(!u)l[r[p]]={count:1};else{let e=r[p].replace(/\d+/gm,o.wildcard);Object.prototype.hasOwnProperty.call(l,e)?(u.forEach((a,c)=>{l[e].elementsWhichWeCanReplaceWithWildcards[c]&&a!==l[e].elementsWhichWeCanReplaceWithWildcards[c]&&(l[e].elementsWhichWeCanReplaceWithWildcards[c]=!1)}),l[e].count+=1):l[e]={count:1,elementsWhichWeCanReplaceWithWildcards:Array.from(u)}}}let t={};return Object.keys(l).forEach(p=>{let i=p;if(Array.isArray(l[p].elementsWhichWeCanReplaceWithWildcards)&&l[p].elementsWhichWeCanReplaceWithWildcards.some(u=>u!==!1)){let u=[],e=0;for(let a=0;a<l[p].elementsWhichWeCanReplaceWithWildcards.length;a++)e=i.indexOf(`${o.wildcard||""}`,e+(o.wildcard||"").length),l[p].elementsWhichWeCanReplaceWithWildcards[a]!==!1&&u.push([e,e+(o.wildcard||"").length,l[p].elementsWhichWeCanReplaceWithWildcards[a]]);i=T(i,u)}t[i]=l[p].count}),t}return _(M);})();
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
